﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
    public class OxygenSyringe : SyringeBehaviour
    {
        public const string name = "​<b></b>" + "Oxygen Syringe";
        public static void Load()
        {
            ModAPI.RegisterLiquid(OxygenSyringeSerum.ID, new OxygenSyringeSerum());

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

                    NameOverride = name,
                    DescriptionOverride = "Syringe that gives the user more oxygen.",

                    CategoryOverride = ModAPI.FindCategory("Polars Bear"),
                    AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<OxygenSyringe>(); }
                }
            );
            Mod.nailgun.SyringeNail(name, typeof(OxygenSyringe));
        }
        public override string GetLiquidID() => OxygenSyringeSerum.ID;
        public class OxygenSyringeSerum : Liquid
        {
            public const string ID = "​<b></b>" + "OXYGEN";
            public OxygenSyringeSerum()
            {
                Color = new UnityEngine.Color(0.80000f, 0.8f, 1.0000f);
            }
            public override void OnEnterLimb(LimbBehaviour limb)
            {
                limb.StartCoroutine(Oxygenate(limb));
            }
            public override void OnExitContainer(BloodContainer container) { }
            public override void OnUpdate(BloodContainer container) { }
            public override void OnEnterContainer(BloodContainer container) { }

            public IEnumerator Oxygenate(LimbBehaviour limb)
            {
                while (limb.CirculationBehaviour.LiquidDistribution.ContainsKey(this))
                {
                    limb.CirculationBehaviour.RemoveLiquid(this, 0.1f * Time.deltaTime);
                    limb.Person.OxygenLevel = 1f;
                    yield return new WaitForEndOfFrame();
                }
            }
        }
    }
}

//Author: Polars Bear
