﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
    public class WeakSyringe : SyringeBehaviour
    {
        public const string name = "​<b></b>" + "Weakness Syringe";
        public static void Load()
        {
            ModAPI.RegisterLiquid(WeakSyringeSerum.ID, new WeakSyringeSerum());

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

                    NameOverride = name,
                    DescriptionOverride = "Syringe that makes the user weak.",

                    CategoryOverride = ModAPI.FindCategory("Polars Bear"),
                    AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<WeakSyringe>(); }
                }
            );
            Mod.nailgun.SyringeNail(name, typeof(WeakSyringe));
        }
        public override string GetLiquidID() => WeakSyringeSerum.ID;
        public class WeakSyringeSerum : libs.OneTimeBodyLiquid
        {
            public const string ID = "​<b></b>" + "WEAKNESS SERUM";
            public WeakSyringeSerum()
            {
                Color = new UnityEngine.Color(0.4f,0f,0.2f);
            }
            public override void OnEnterLimb(LimbBehaviour limb)
            {
                base.OnEnterLimb(limb);
                limb.gameObject.GetOrAddComponent<Weakness>();
            }

            class Weakness : MonoBehaviour
            {
                LimbBehaviour limb;
                void Start()
                {
                    limb = GetComponent<LimbBehaviour>();
                    limb.BaseStrength *= 0.5f;
                    limb.BreakingThreshold *= 0.75f;
                    limb.InitialHealth *= 0.5f;
                    limb.Health *= 0.5f;
                }
                void OnDestroy()
                {
                    limb.BaseStrength *= 2f;
                    limb.BreakingThreshold *= 1.333f;
                    limb.InitialHealth *= 2f;
                    limb.Health *= 2f;
                }
            }

        }

    }
}

//Author: Polars Bear
